import { Action } from '@ngrx/store';

import { RESTClientError } from '@loafer/ng-rest/protocol';

import { Member } from '@overflow/commons-typescript/model/member';

export enum ActionType {
  ResetPassword = '[member.resetPassword] ResetPassword',
  ResetPasswordSuccess = '[member.resetPassword] ResetPasswordSuccess',
  ResetPasswordFailure = '[member.resetPassword] ResetPasswordFailure',
}

export class ResetPassword implements Action {
  readonly type = ActionType.ResetPassword;

  constructor(public payload: string ) {}
}

export class ResetPasswordSuccess implements Action {
  readonly type = ActionType.ResetPasswordSuccess;

  constructor(public payload: Member) {}
}

export class ResetPasswordFailure implements Action {
  readonly type = ActionType.ResetPasswordFailure;

  constructor(public payload: RESTClientError) {}
}

export type Actions =
  | ResetPassword
  | ResetPasswordSuccess
  | ResetPasswordFailure
;
